
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 05/30/2012 21:07:16
-- Generated from EDMX file: C:\EduCloudWeb\EduCloud\EduCloud\Models\EduDB.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [db0202];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_TimeGradeYearPlanTimeSemesterPlan]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TimeSemesterPlans] DROP CONSTRAINT [FK_TimeGradeYearPlanTimeSemesterPlan];
GO
IF OBJECT_ID(N'[dbo].[FK_TimeSemesterPlanTimeWeekPlan]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TimeWeekPlans] DROP CONSTRAINT [FK_TimeSemesterPlanTimeWeekPlan];
GO
IF OBJECT_ID(N'[dbo].[FK_TimeSemesterPlanCourse]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Courses] DROP CONSTRAINT [FK_TimeSemesterPlanCourse];
GO
IF OBJECT_ID(N'[dbo].[FK_WeekCoursePlanCourse]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[WeekCoursePlans] DROP CONSTRAINT [FK_WeekCoursePlanCourse];
GO
IF OBJECT_ID(N'[dbo].[FK_WeekCoursePlanWeekSkema]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[WeekCoursePlans] DROP CONSTRAINT [FK_WeekCoursePlanWeekSkema];
GO
IF OBJECT_ID(N'[dbo].[FK_TimeHourPlanWeekCoursePlan]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TimeWeekHourPlans] DROP CONSTRAINT [FK_TimeHourPlanWeekCoursePlan];
GO
IF OBJECT_ID(N'[dbo].[FK_CourseSubject]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Courses] DROP CONSTRAINT [FK_CourseSubject];
GO
IF OBJECT_ID(N'[dbo].[FK_SectionYearGrade]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[YearGrades] DROP CONSTRAINT [FK_SectionYearGrade];
GO
IF OBJECT_ID(N'[dbo].[FK_SectionSubject]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Subjects] DROP CONSTRAINT [FK_SectionSubject];
GO
IF OBJECT_ID(N'[dbo].[FK_YearGradeClass]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Classes] DROP CONSTRAINT [FK_YearGradeClass];
GO
IF OBJECT_ID(N'[dbo].[FK_ClassStudent]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Students] DROP CONSTRAINT [FK_ClassStudent];
GO
IF OBJECT_ID(N'[dbo].[FK_StudentStudentProfile]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[StudentProfiles] DROP CONSTRAINT [FK_StudentStudentProfile];
GO
IF OBJECT_ID(N'[dbo].[FK_StudentStudentSemesterProfile]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[StudentSemesterProfiles] DROP CONSTRAINT [FK_StudentStudentSemesterProfile];
GO
IF OBJECT_ID(N'[dbo].[FK_TimeSemesterPlanStudentSemesterProfile]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[StudentSemesterProfiles] DROP CONSTRAINT [FK_TimeSemesterPlanStudentSemesterProfile];
GO
IF OBJECT_ID(N'[dbo].[FK_YearGradeTimeGradeYearPlan]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TimeGradeYearPlans] DROP CONSTRAINT [FK_YearGradeTimeGradeYearPlan];
GO
IF OBJECT_ID(N'[dbo].[FK_SubSchoolSection]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Sections] DROP CONSTRAINT [FK_SubSchoolSection];
GO
IF OBJECT_ID(N'[dbo].[FK_SubjectTeacher]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Teachers] DROP CONSTRAINT [FK_SubjectTeacher];
GO
IF OBJECT_ID(N'[dbo].[FK_TeacherTeacherProfile]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TeacherProfiles] DROP CONSTRAINT [FK_TeacherTeacherProfile];
GO
IF OBJECT_ID(N'[dbo].[FK_TeacherTeacherSemesterProfile]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TeacherSemesterProfiles] DROP CONSTRAINT [FK_TeacherTeacherSemesterProfile];
GO
IF OBJECT_ID(N'[dbo].[FK_TimeSemesterPlanTeacherSemesterProfile]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TeacherSemesterProfiles] DROP CONSTRAINT [FK_TimeSemesterPlanTeacherSemesterProfile];
GO
IF OBJECT_ID(N'[dbo].[FK_DWeekDayWeekSkema]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[WeekSkemas] DROP CONSTRAINT [FK_DWeekDayWeekSkema];
GO
IF OBJECT_ID(N'[dbo].[FK_DClassHourWeekSkema]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[WeekSkemas] DROP CONSTRAINT [FK_DClassHourWeekSkema];
GO
IF OBJECT_ID(N'[dbo].[FK_TimeWeekPlanTimeClassHourPlan]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TimeWeekHourPlans] DROP CONSTRAINT [FK_TimeWeekPlanTimeClassHourPlan];
GO
IF OBJECT_ID(N'[dbo].[FK_SchoolSubSchool]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[SubSchools] DROP CONSTRAINT [FK_SchoolSubSchool];
GO
IF OBJECT_ID(N'[dbo].[FK_SchoolYearSchoolSemester]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[SchoolSemesters] DROP CONSTRAINT [FK_SchoolYearSchoolSemester];
GO
IF OBJECT_ID(N'[dbo].[FK_SchoolSemesterSchoolWeek]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[SchoolWeeks] DROP CONSTRAINT [FK_SchoolSemesterSchoolWeek];
GO
IF OBJECT_ID(N'[dbo].[FK_SchoolWeekSchoolDay]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[SchoolDays] DROP CONSTRAINT [FK_SchoolWeekSchoolDay];
GO
IF OBJECT_ID(N'[dbo].[FK_MembershipUser]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Memberships] DROP CONSTRAINT [FK_MembershipUser];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Schools]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Schools];
GO
IF OBJECT_ID(N'[dbo].[SubSchools]', 'U') IS NOT NULL
    DROP TABLE [dbo].[SubSchools];
GO
IF OBJECT_ID(N'[dbo].[Sections]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Sections];
GO
IF OBJECT_ID(N'[dbo].[Students]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Students];
GO
IF OBJECT_ID(N'[dbo].[TimeSemesterPlans]', 'U') IS NOT NULL
    DROP TABLE [dbo].[TimeSemesterPlans];
GO
IF OBJECT_ID(N'[dbo].[TimeGradeYearPlans]', 'U') IS NOT NULL
    DROP TABLE [dbo].[TimeGradeYearPlans];
GO
IF OBJECT_ID(N'[dbo].[Subjects]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Subjects];
GO
IF OBJECT_ID(N'[dbo].[Courses]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Courses];
GO
IF OBJECT_ID(N'[dbo].[TimeWeekPlans]', 'U') IS NOT NULL
    DROP TABLE [dbo].[TimeWeekPlans];
GO
IF OBJECT_ID(N'[dbo].[WeekSkemas]', 'U') IS NOT NULL
    DROP TABLE [dbo].[WeekSkemas];
GO
IF OBJECT_ID(N'[dbo].[WeekCoursePlans]', 'U') IS NOT NULL
    DROP TABLE [dbo].[WeekCoursePlans];
GO
IF OBJECT_ID(N'[dbo].[TimeWeekHourPlans]', 'U') IS NOT NULL
    DROP TABLE [dbo].[TimeWeekHourPlans];
GO
IF OBJECT_ID(N'[dbo].[StudentProfiles]', 'U') IS NOT NULL
    DROP TABLE [dbo].[StudentProfiles];
GO
IF OBJECT_ID(N'[dbo].[StudentSemesterProfiles]', 'U') IS NOT NULL
    DROP TABLE [dbo].[StudentSemesterProfiles];
GO
IF OBJECT_ID(N'[dbo].[YearGrades]', 'U') IS NOT NULL
    DROP TABLE [dbo].[YearGrades];
GO
IF OBJECT_ID(N'[dbo].[Classes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Classes];
GO
IF OBJECT_ID(N'[dbo].[Teachers]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Teachers];
GO
IF OBJECT_ID(N'[dbo].[TeacherProfiles]', 'U') IS NOT NULL
    DROP TABLE [dbo].[TeacherProfiles];
GO
IF OBJECT_ID(N'[dbo].[TeacherSemesterProfiles]', 'U') IS NOT NULL
    DROP TABLE [dbo].[TeacherSemesterProfiles];
GO
IF OBJECT_ID(N'[dbo].[DWeekDays]', 'U') IS NOT NULL
    DROP TABLE [dbo].[DWeekDays];
GO
IF OBJECT_ID(N'[dbo].[DClassHours]', 'U') IS NOT NULL
    DROP TABLE [dbo].[DClassHours];
GO
IF OBJECT_ID(N'[dbo].[Entities]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Entities];
GO
IF OBJECT_ID(N'[dbo].[SchoolYears]', 'U') IS NOT NULL
    DROP TABLE [dbo].[SchoolYears];
GO
IF OBJECT_ID(N'[dbo].[SchoolSemesters]', 'U') IS NOT NULL
    DROP TABLE [dbo].[SchoolSemesters];
GO
IF OBJECT_ID(N'[dbo].[SchoolWeeks]', 'U') IS NOT NULL
    DROP TABLE [dbo].[SchoolWeeks];
GO
IF OBJECT_ID(N'[dbo].[SchoolDays]', 'U') IS NOT NULL
    DROP TABLE [dbo].[SchoolDays];
GO
IF OBJECT_ID(N'[dbo].[EntityDics]', 'U') IS NOT NULL
    DROP TABLE [dbo].[EntityDics];
GO
IF OBJECT_ID(N'[dbo].[Memberships]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Memberships];
GO
IF OBJECT_ID(N'[dbo].[Users]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Users];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Schools'
CREATE TABLE [dbo].[Schools] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Descp] nvarchar(max)  NULL
);
GO

-- Creating table 'SubSchools'
CREATE TABLE [dbo].[SubSchools] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Descp] nvarchar(max)  NULL,
    [SchoolID] int  NOT NULL
);
GO

-- Creating table 'Sections'
CREATE TABLE [dbo].[Sections] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Descp] nvarchar(max)  NOT NULL,
    [SubSchoolID] int  NOT NULL
);
GO

-- Creating table 'Students'
CREATE TABLE [dbo].[Students] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [ClassID] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'TimeSemesterPlans'
CREATE TABLE [dbo].[TimeSemesterPlans] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [TimeGradeYearPlanID] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'TimeGradeYearPlans'
CREATE TABLE [dbo].[TimeGradeYearPlans] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [YearGradeID] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Subjects'
CREATE TABLE [dbo].[Subjects] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [SectionID] int  NOT NULL
);
GO

-- Creating table 'Courses'
CREATE TABLE [dbo].[Courses] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [TimeSemesterPlanID] int  NOT NULL,
    [SubjectID] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'TimeWeekPlans'
CREATE TABLE [dbo].[TimeWeekPlans] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [TimeSemesterPlanID] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'WeekSkemas'
CREATE TABLE [dbo].[WeekSkemas] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [DWeekDayID] int  NOT NULL,
    [DClassHourID] int  NOT NULL
);
GO

-- Creating table 'WeekCoursePlans'
CREATE TABLE [dbo].[WeekCoursePlans] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [CourseID] int  NOT NULL,
    [WeekSkemaID] int  NOT NULL
);
GO

-- Creating table 'TimeWeekHourPlans'
CREATE TABLE [dbo].[TimeWeekHourPlans] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [WeekCoursePlanID] int  NOT NULL,
    [TimeWeekPlanID] int  NOT NULL
);
GO

-- Creating table 'StudentProfiles'
CREATE TABLE [dbo].[StudentProfiles] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [StudentID] int  NOT NULL
);
GO

-- Creating table 'StudentSemesterProfiles'
CREATE TABLE [dbo].[StudentSemesterProfiles] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [StudentID] int  NOT NULL,
    [TimeSemesterPlanID] int  NOT NULL
);
GO

-- Creating table 'YearGrades'
CREATE TABLE [dbo].[YearGrades] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [SectionID] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Classes'
CREATE TABLE [dbo].[Classes] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [YearGradeID] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Teachers'
CREATE TABLE [dbo].[Teachers] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [SubjectID] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'TeacherProfiles'
CREATE TABLE [dbo].[TeacherProfiles] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [TeacherID] int  NOT NULL
);
GO

-- Creating table 'TeacherSemesterProfiles'
CREATE TABLE [dbo].[TeacherSemesterProfiles] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [TeacherID] int  NOT NULL,
    [TimeSemesterPlanID] int  NOT NULL
);
GO

-- Creating table 'DWeekDays'
CREATE TABLE [dbo].[DWeekDays] (
    [ID] int IDENTITY(1,1) NOT NULL
);
GO

-- Creating table 'DClassHours'
CREATE TABLE [dbo].[DClassHours] (
    [ID] int IDENTITY(1,1) NOT NULL
);
GO

-- Creating table 'Entities'
CREATE TABLE [dbo].[Entities] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Type] nvarchar(30)  NOT NULL,
    [ParentID] int  NOT NULL,
    [Description] nvarchar(20)  NULL,
    [edID] int  NOT NULL,
    [AuthorID] int  NOT NULL,
    [DateTime] datetime  NOT NULL,
    [Memo] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'SchoolYears'
CREATE TABLE [dbo].[SchoolYears] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [EntityID] int  NOT NULL
);
GO

-- Creating table 'SchoolSemesters'
CREATE TABLE [dbo].[SchoolSemesters] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [SchoolYearID] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [StartDate] datetime  NOT NULL,
    [EndDate] datetime  NOT NULL
);
GO

-- Creating table 'SchoolWeeks'
CREATE TABLE [dbo].[SchoolWeeks] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [SchoolSemesterID] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [StartDate] datetime  NOT NULL,
    [EndDate] datetime  NOT NULL
);
GO

-- Creating table 'SchoolDays'
CREATE TABLE [dbo].[SchoolDays] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [SchoolWeekID] int  NOT NULL,
    [TheDate] datetime  NOT NULL,
    [WeekDay] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'EntityDics'
CREATE TABLE [dbo].[EntityDics] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(50)  NOT NULL,
    [Type] nvarchar(30)  NOT NULL,
    [ParentID] int  NOT NULL,
    [Description] nvarchar(max)  NULL,
    [Action] nvarchar(10)  NULL,
    [HowMany] int  NULL,
    [FromID] int  NULL,
    [FromType] nvarchar(50)  NULL,
    [TreePlace] nvarchar(10)  NULL,
    [DefaultVal] nvarchar(max)  NULL,
    [SN] int  NOT NULL,
    [R] nvarchar(200)  NOT NULL,
    [W] nvarchar(200)  NOT NULL
);
GO

-- Creating table 'Memberships'
CREATE TABLE [dbo].[Memberships] (
    [ApplicationId] uniqueidentifier  NOT NULL,
    [UserId] uniqueidentifier  NOT NULL,
    [Password] nvarchar(128)  NOT NULL,
    [PasswordFormat] int  NOT NULL,
    [PasswordSalt] nvarchar(128)  NOT NULL,
    [Email] nvarchar(256)  NULL,
    [PasswordQuestion] nvarchar(256)  NULL,
    [PasswordAnswer] nvarchar(128)  NULL,
    [IsApproved] bit  NOT NULL,
    [IsLockedOut] bit  NOT NULL,
    [CreateDate] datetime  NOT NULL,
    [LastLoginDate] datetime  NOT NULL,
    [LastPasswordChangedDate] datetime  NOT NULL,
    [LastLockoutDate] datetime  NOT NULL,
    [FailedPasswordAttemptCount] int  NOT NULL,
    [FailedPasswordAttemptWindowStart] datetime  NOT NULL,
    [FailedPasswordAnswerAttemptCount] int  NOT NULL,
    [FailedPasswordAnswerAttemptWindowsStart] datetime  NOT NULL,
    [Comment] nvarchar(256)  NULL
);
GO

-- Creating table 'Users'
CREATE TABLE [dbo].[Users] (
    [ApplicationId] uniqueidentifier  NOT NULL,
    [UserId] uniqueidentifier  NOT NULL,
    [UserName] nvarchar(50)  NOT NULL,
    [IsAnonymous] bit  NOT NULL,
    [LastActivityDate] datetime  NOT NULL
);
GO

-- Creating table 'ScheduleDatas'
CREATE TABLE [dbo].[ScheduleDatas] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [TeacherID] int  NULL,
    [CourseID] int  NULL,
    [Day] int  NULL,
    [Hour] int  NULL,
    [ClassID] int  NULL,
    [GradeID] int  NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [ID] in table 'Schools'
ALTER TABLE [dbo].[Schools]
ADD CONSTRAINT [PK_Schools]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'SubSchools'
ALTER TABLE [dbo].[SubSchools]
ADD CONSTRAINT [PK_SubSchools]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'Sections'
ALTER TABLE [dbo].[Sections]
ADD CONSTRAINT [PK_Sections]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'Students'
ALTER TABLE [dbo].[Students]
ADD CONSTRAINT [PK_Students]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'TimeSemesterPlans'
ALTER TABLE [dbo].[TimeSemesterPlans]
ADD CONSTRAINT [PK_TimeSemesterPlans]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'TimeGradeYearPlans'
ALTER TABLE [dbo].[TimeGradeYearPlans]
ADD CONSTRAINT [PK_TimeGradeYearPlans]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'Subjects'
ALTER TABLE [dbo].[Subjects]
ADD CONSTRAINT [PK_Subjects]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'Courses'
ALTER TABLE [dbo].[Courses]
ADD CONSTRAINT [PK_Courses]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'TimeWeekPlans'
ALTER TABLE [dbo].[TimeWeekPlans]
ADD CONSTRAINT [PK_TimeWeekPlans]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'WeekSkemas'
ALTER TABLE [dbo].[WeekSkemas]
ADD CONSTRAINT [PK_WeekSkemas]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'WeekCoursePlans'
ALTER TABLE [dbo].[WeekCoursePlans]
ADD CONSTRAINT [PK_WeekCoursePlans]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'TimeWeekHourPlans'
ALTER TABLE [dbo].[TimeWeekHourPlans]
ADD CONSTRAINT [PK_TimeWeekHourPlans]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'StudentProfiles'
ALTER TABLE [dbo].[StudentProfiles]
ADD CONSTRAINT [PK_StudentProfiles]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'StudentSemesterProfiles'
ALTER TABLE [dbo].[StudentSemesterProfiles]
ADD CONSTRAINT [PK_StudentSemesterProfiles]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'YearGrades'
ALTER TABLE [dbo].[YearGrades]
ADD CONSTRAINT [PK_YearGrades]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'Classes'
ALTER TABLE [dbo].[Classes]
ADD CONSTRAINT [PK_Classes]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'Teachers'
ALTER TABLE [dbo].[Teachers]
ADD CONSTRAINT [PK_Teachers]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'TeacherProfiles'
ALTER TABLE [dbo].[TeacherProfiles]
ADD CONSTRAINT [PK_TeacherProfiles]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'TeacherSemesterProfiles'
ALTER TABLE [dbo].[TeacherSemesterProfiles]
ADD CONSTRAINT [PK_TeacherSemesterProfiles]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'DWeekDays'
ALTER TABLE [dbo].[DWeekDays]
ADD CONSTRAINT [PK_DWeekDays]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'DClassHours'
ALTER TABLE [dbo].[DClassHours]
ADD CONSTRAINT [PK_DClassHours]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'Entities'
ALTER TABLE [dbo].[Entities]
ADD CONSTRAINT [PK_Entities]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'SchoolYears'
ALTER TABLE [dbo].[SchoolYears]
ADD CONSTRAINT [PK_SchoolYears]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'SchoolSemesters'
ALTER TABLE [dbo].[SchoolSemesters]
ADD CONSTRAINT [PK_SchoolSemesters]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'SchoolWeeks'
ALTER TABLE [dbo].[SchoolWeeks]
ADD CONSTRAINT [PK_SchoolWeeks]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'SchoolDays'
ALTER TABLE [dbo].[SchoolDays]
ADD CONSTRAINT [PK_SchoolDays]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'EntityDics'
ALTER TABLE [dbo].[EntityDics]
ADD CONSTRAINT [PK_EntityDics]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [UserId] in table 'Memberships'
ALTER TABLE [dbo].[Memberships]
ADD CONSTRAINT [PK_Memberships]
    PRIMARY KEY CLUSTERED ([UserId] ASC);
GO

-- Creating primary key on [UserId] in table 'Users'
ALTER TABLE [dbo].[Users]
ADD CONSTRAINT [PK_Users]
    PRIMARY KEY CLUSTERED ([UserId] ASC);
GO

-- Creating primary key on [ID] in table 'ScheduleDatas'
ALTER TABLE [dbo].[ScheduleDatas]
ADD CONSTRAINT [PK_ScheduleDatas]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [TimeGradeYearPlanID] in table 'TimeSemesterPlans'
ALTER TABLE [dbo].[TimeSemesterPlans]
ADD CONSTRAINT [FK_TimeGradeYearPlanTimeSemesterPlan]
    FOREIGN KEY ([TimeGradeYearPlanID])
    REFERENCES [dbo].[TimeGradeYearPlans]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TimeGradeYearPlanTimeSemesterPlan'
CREATE INDEX [IX_FK_TimeGradeYearPlanTimeSemesterPlan]
ON [dbo].[TimeSemesterPlans]
    ([TimeGradeYearPlanID]);
GO

-- Creating foreign key on [TimeSemesterPlanID] in table 'TimeWeekPlans'
ALTER TABLE [dbo].[TimeWeekPlans]
ADD CONSTRAINT [FK_TimeSemesterPlanTimeWeekPlan]
    FOREIGN KEY ([TimeSemesterPlanID])
    REFERENCES [dbo].[TimeSemesterPlans]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TimeSemesterPlanTimeWeekPlan'
CREATE INDEX [IX_FK_TimeSemesterPlanTimeWeekPlan]
ON [dbo].[TimeWeekPlans]
    ([TimeSemesterPlanID]);
GO

-- Creating foreign key on [TimeSemesterPlanID] in table 'Courses'
ALTER TABLE [dbo].[Courses]
ADD CONSTRAINT [FK_TimeSemesterPlanCourse]
    FOREIGN KEY ([TimeSemesterPlanID])
    REFERENCES [dbo].[TimeSemesterPlans]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TimeSemesterPlanCourse'
CREATE INDEX [IX_FK_TimeSemesterPlanCourse]
ON [dbo].[Courses]
    ([TimeSemesterPlanID]);
GO

-- Creating foreign key on [CourseID] in table 'WeekCoursePlans'
ALTER TABLE [dbo].[WeekCoursePlans]
ADD CONSTRAINT [FK_WeekCoursePlanCourse]
    FOREIGN KEY ([CourseID])
    REFERENCES [dbo].[Courses]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_WeekCoursePlanCourse'
CREATE INDEX [IX_FK_WeekCoursePlanCourse]
ON [dbo].[WeekCoursePlans]
    ([CourseID]);
GO

-- Creating foreign key on [WeekSkemaID] in table 'WeekCoursePlans'
ALTER TABLE [dbo].[WeekCoursePlans]
ADD CONSTRAINT [FK_WeekCoursePlanWeekSkema]
    FOREIGN KEY ([WeekSkemaID])
    REFERENCES [dbo].[WeekSkemas]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_WeekCoursePlanWeekSkema'
CREATE INDEX [IX_FK_WeekCoursePlanWeekSkema]
ON [dbo].[WeekCoursePlans]
    ([WeekSkemaID]);
GO

-- Creating foreign key on [WeekCoursePlanID] in table 'TimeWeekHourPlans'
ALTER TABLE [dbo].[TimeWeekHourPlans]
ADD CONSTRAINT [FK_TimeHourPlanWeekCoursePlan]
    FOREIGN KEY ([WeekCoursePlanID])
    REFERENCES [dbo].[WeekCoursePlans]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TimeHourPlanWeekCoursePlan'
CREATE INDEX [IX_FK_TimeHourPlanWeekCoursePlan]
ON [dbo].[TimeWeekHourPlans]
    ([WeekCoursePlanID]);
GO

-- Creating foreign key on [SubjectID] in table 'Courses'
ALTER TABLE [dbo].[Courses]
ADD CONSTRAINT [FK_CourseSubject]
    FOREIGN KEY ([SubjectID])
    REFERENCES [dbo].[Subjects]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_CourseSubject'
CREATE INDEX [IX_FK_CourseSubject]
ON [dbo].[Courses]
    ([SubjectID]);
GO

-- Creating foreign key on [SectionID] in table 'YearGrades'
ALTER TABLE [dbo].[YearGrades]
ADD CONSTRAINT [FK_SectionYearGrade]
    FOREIGN KEY ([SectionID])
    REFERENCES [dbo].[Sections]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_SectionYearGrade'
CREATE INDEX [IX_FK_SectionYearGrade]
ON [dbo].[YearGrades]
    ([SectionID]);
GO

-- Creating foreign key on [SectionID] in table 'Subjects'
ALTER TABLE [dbo].[Subjects]
ADD CONSTRAINT [FK_SectionSubject]
    FOREIGN KEY ([SectionID])
    REFERENCES [dbo].[Sections]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_SectionSubject'
CREATE INDEX [IX_FK_SectionSubject]
ON [dbo].[Subjects]
    ([SectionID]);
GO

-- Creating foreign key on [YearGradeID] in table 'Classes'
ALTER TABLE [dbo].[Classes]
ADD CONSTRAINT [FK_YearGradeClass]
    FOREIGN KEY ([YearGradeID])
    REFERENCES [dbo].[YearGrades]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_YearGradeClass'
CREATE INDEX [IX_FK_YearGradeClass]
ON [dbo].[Classes]
    ([YearGradeID]);
GO

-- Creating foreign key on [ClassID] in table 'Students'
ALTER TABLE [dbo].[Students]
ADD CONSTRAINT [FK_ClassStudent]
    FOREIGN KEY ([ClassID])
    REFERENCES [dbo].[Classes]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ClassStudent'
CREATE INDEX [IX_FK_ClassStudent]
ON [dbo].[Students]
    ([ClassID]);
GO

-- Creating foreign key on [StudentID] in table 'StudentProfiles'
ALTER TABLE [dbo].[StudentProfiles]
ADD CONSTRAINT [FK_StudentStudentProfile]
    FOREIGN KEY ([StudentID])
    REFERENCES [dbo].[Students]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_StudentStudentProfile'
CREATE INDEX [IX_FK_StudentStudentProfile]
ON [dbo].[StudentProfiles]
    ([StudentID]);
GO

-- Creating foreign key on [StudentID] in table 'StudentSemesterProfiles'
ALTER TABLE [dbo].[StudentSemesterProfiles]
ADD CONSTRAINT [FK_StudentStudentSemesterProfile]
    FOREIGN KEY ([StudentID])
    REFERENCES [dbo].[Students]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_StudentStudentSemesterProfile'
CREATE INDEX [IX_FK_StudentStudentSemesterProfile]
ON [dbo].[StudentSemesterProfiles]
    ([StudentID]);
GO

-- Creating foreign key on [TimeSemesterPlanID] in table 'StudentSemesterProfiles'
ALTER TABLE [dbo].[StudentSemesterProfiles]
ADD CONSTRAINT [FK_TimeSemesterPlanStudentSemesterProfile]
    FOREIGN KEY ([TimeSemesterPlanID])
    REFERENCES [dbo].[TimeSemesterPlans]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TimeSemesterPlanStudentSemesterProfile'
CREATE INDEX [IX_FK_TimeSemesterPlanStudentSemesterProfile]
ON [dbo].[StudentSemesterProfiles]
    ([TimeSemesterPlanID]);
GO

-- Creating foreign key on [YearGradeID] in table 'TimeGradeYearPlans'
ALTER TABLE [dbo].[TimeGradeYearPlans]
ADD CONSTRAINT [FK_YearGradeTimeGradeYearPlan]
    FOREIGN KEY ([YearGradeID])
    REFERENCES [dbo].[YearGrades]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_YearGradeTimeGradeYearPlan'
CREATE INDEX [IX_FK_YearGradeTimeGradeYearPlan]
ON [dbo].[TimeGradeYearPlans]
    ([YearGradeID]);
GO

-- Creating foreign key on [SubSchoolID] in table 'Sections'
ALTER TABLE [dbo].[Sections]
ADD CONSTRAINT [FK_SubSchoolSection]
    FOREIGN KEY ([SubSchoolID])
    REFERENCES [dbo].[SubSchools]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_SubSchoolSection'
CREATE INDEX [IX_FK_SubSchoolSection]
ON [dbo].[Sections]
    ([SubSchoolID]);
GO

-- Creating foreign key on [SubjectID] in table 'Teachers'
ALTER TABLE [dbo].[Teachers]
ADD CONSTRAINT [FK_SubjectTeacher]
    FOREIGN KEY ([SubjectID])
    REFERENCES [dbo].[Subjects]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_SubjectTeacher'
CREATE INDEX [IX_FK_SubjectTeacher]
ON [dbo].[Teachers]
    ([SubjectID]);
GO

-- Creating foreign key on [TeacherID] in table 'TeacherProfiles'
ALTER TABLE [dbo].[TeacherProfiles]
ADD CONSTRAINT [FK_TeacherTeacherProfile]
    FOREIGN KEY ([TeacherID])
    REFERENCES [dbo].[Teachers]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TeacherTeacherProfile'
CREATE INDEX [IX_FK_TeacherTeacherProfile]
ON [dbo].[TeacherProfiles]
    ([TeacherID]);
GO

-- Creating foreign key on [TeacherID] in table 'TeacherSemesterProfiles'
ALTER TABLE [dbo].[TeacherSemesterProfiles]
ADD CONSTRAINT [FK_TeacherTeacherSemesterProfile]
    FOREIGN KEY ([TeacherID])
    REFERENCES [dbo].[Teachers]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TeacherTeacherSemesterProfile'
CREATE INDEX [IX_FK_TeacherTeacherSemesterProfile]
ON [dbo].[TeacherSemesterProfiles]
    ([TeacherID]);
GO

-- Creating foreign key on [TimeSemesterPlanID] in table 'TeacherSemesterProfiles'
ALTER TABLE [dbo].[TeacherSemesterProfiles]
ADD CONSTRAINT [FK_TimeSemesterPlanTeacherSemesterProfile]
    FOREIGN KEY ([TimeSemesterPlanID])
    REFERENCES [dbo].[TimeSemesterPlans]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TimeSemesterPlanTeacherSemesterProfile'
CREATE INDEX [IX_FK_TimeSemesterPlanTeacherSemesterProfile]
ON [dbo].[TeacherSemesterProfiles]
    ([TimeSemesterPlanID]);
GO

-- Creating foreign key on [DWeekDayID] in table 'WeekSkemas'
ALTER TABLE [dbo].[WeekSkemas]
ADD CONSTRAINT [FK_DWeekDayWeekSkema]
    FOREIGN KEY ([DWeekDayID])
    REFERENCES [dbo].[DWeekDays]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_DWeekDayWeekSkema'
CREATE INDEX [IX_FK_DWeekDayWeekSkema]
ON [dbo].[WeekSkemas]
    ([DWeekDayID]);
GO

-- Creating foreign key on [DClassHourID] in table 'WeekSkemas'
ALTER TABLE [dbo].[WeekSkemas]
ADD CONSTRAINT [FK_DClassHourWeekSkema]
    FOREIGN KEY ([DClassHourID])
    REFERENCES [dbo].[DClassHours]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_DClassHourWeekSkema'
CREATE INDEX [IX_FK_DClassHourWeekSkema]
ON [dbo].[WeekSkemas]
    ([DClassHourID]);
GO

-- Creating foreign key on [TimeWeekPlanID] in table 'TimeWeekHourPlans'
ALTER TABLE [dbo].[TimeWeekHourPlans]
ADD CONSTRAINT [FK_TimeWeekPlanTimeClassHourPlan]
    FOREIGN KEY ([TimeWeekPlanID])
    REFERENCES [dbo].[TimeWeekPlans]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TimeWeekPlanTimeClassHourPlan'
CREATE INDEX [IX_FK_TimeWeekPlanTimeClassHourPlan]
ON [dbo].[TimeWeekHourPlans]
    ([TimeWeekPlanID]);
GO

-- Creating foreign key on [SchoolID] in table 'SubSchools'
ALTER TABLE [dbo].[SubSchools]
ADD CONSTRAINT [FK_SchoolSubSchool]
    FOREIGN KEY ([SchoolID])
    REFERENCES [dbo].[Schools]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_SchoolSubSchool'
CREATE INDEX [IX_FK_SchoolSubSchool]
ON [dbo].[SubSchools]
    ([SchoolID]);
GO

-- Creating foreign key on [SchoolYearID] in table 'SchoolSemesters'
ALTER TABLE [dbo].[SchoolSemesters]
ADD CONSTRAINT [FK_SchoolYearSchoolSemester]
    FOREIGN KEY ([SchoolYearID])
    REFERENCES [dbo].[SchoolYears]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_SchoolYearSchoolSemester'
CREATE INDEX [IX_FK_SchoolYearSchoolSemester]
ON [dbo].[SchoolSemesters]
    ([SchoolYearID]);
GO

-- Creating foreign key on [SchoolSemesterID] in table 'SchoolWeeks'
ALTER TABLE [dbo].[SchoolWeeks]
ADD CONSTRAINT [FK_SchoolSemesterSchoolWeek]
    FOREIGN KEY ([SchoolSemesterID])
    REFERENCES [dbo].[SchoolSemesters]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_SchoolSemesterSchoolWeek'
CREATE INDEX [IX_FK_SchoolSemesterSchoolWeek]
ON [dbo].[SchoolWeeks]
    ([SchoolSemesterID]);
GO

-- Creating foreign key on [SchoolWeekID] in table 'SchoolDays'
ALTER TABLE [dbo].[SchoolDays]
ADD CONSTRAINT [FK_SchoolWeekSchoolDay]
    FOREIGN KEY ([SchoolWeekID])
    REFERENCES [dbo].[SchoolWeeks]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_SchoolWeekSchoolDay'
CREATE INDEX [IX_FK_SchoolWeekSchoolDay]
ON [dbo].[SchoolDays]
    ([SchoolWeekID]);
GO

-- Creating foreign key on [UserId] in table 'Memberships'
ALTER TABLE [dbo].[Memberships]
ADD CONSTRAINT [FK_MembershipUser]
    FOREIGN KEY ([UserId])
    REFERENCES [dbo].[Users]
        ([UserId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------